| OpenCV 3.4.8 Open Source Computer Vision

Modules | Typedefs | Enumerations | Functions
High-level GUI

## Modules
| OpenGL support
| Qt New Functions
| WinRT support
| C API

## Typedefs
typedef void(* | cv::ButtonCallback) (int state, void *userdata)
| Callback function for a button created by cv::createButton. More...
typedef void(* | cv::MouseCallback) (int event, int x, int y, int flags, void *userdata)
| Callback function for mouse events. see cv::setMouseCallback. More...
typedef void(* | cv::OpenGlDrawCallback) (void *userdata)
| Callback function defined to be called every frame. See cv::setOpenGlDrawCallback. More...
typedef void(* | cv::TrackbarCallback) (int pos, void *userdata)
| Callback function for Trackbar see cv::createTrackbar. More...

## Enumerations
enum | cv::MouseEventFlags { cv::EVENT_FLAG_LBUTTON = 1, cv::EVENT_FLAG_RBUTTON = 2, cv::EVENT_FLAG_MBUTTON = 4, cv::EVENT_FLAG_CTRLKEY = 8, cv::EVENT_FLAG_SHIFTKEY = 16, cv::EVENT_FLAG_ALTKEY = 32 }
| Mouse Event Flags see cv::MouseCallback. More...
enum | cv::MouseEventTypes { cv::EVENT_MOUSEMOVE = 0, cv::EVENT_LBUTTONDOWN = 1, cv::EVENT_RBUTTONDOWN = 2, cv::EVENT_MBUTTONDOWN = 3, cv::EVENT_LBUTTONUP = 4, cv::EVENT_RBUTTONUP = 5, cv::EVENT_MBUTTONUP = 6, cv::EVENT_LBUTTONDBLCLK = 7, cv::EVENT_RBUTTONDBLCLK = 8, cv::EVENT_MBUTTONDBLCLK = 9, cv::EVENT_MOUSEWHEEL = 10, cv::EVENT_MOUSEHWHEEL = 11 }
| Mouse Events see cv::MouseCallback. More...
enum | cv::QtButtonTypes { cv::QT_PUSH_BUTTON = 0, cv::QT_CHECKBOX = 1, cv::QT_RADIOBOX = 2, cv::QT_NEW_BUTTONBAR = 1024 }
| Qt "button" type. More...
enum | cv::QtFontStyles { cv::QT_STYLE_NORMAL = 0, cv::QT_STYLE_ITALIC = 1, cv::QT_STYLE_OBLIQUE = 2 }
| Qt font style. More...
enum | cv::QtFontWeights { cv::QT_FONT_LIGHT = 25, cv::QT_FONT_NORMAL = 50, cv::QT_FONT_DEMIBOLD = 63, cv::QT_FONT_BOLD = 75, cv::QT_FONT_BLACK = 87 }
| Qt font weight. More...
enum | cv::WindowFlags { cv::WINDOW_NORMAL = 0x00000000, cv::WINDOW_AUTOSIZE = 0x00000001, cv::WINDOW_OPENGL = 0x00001000, cv::WINDOW_FULLSCREEN = 1, cv::WINDOW_FREERATIO = 0x00000100, cv::WINDOW_KEEPRATIO = 0x00000000, cv::WINDOW_GUI_EXPANDED =0x00000000, cv::WINDOW_GUI_NORMAL = 0x00000010 }
| Flags for cv::namedWindow. More...
enum | cv::WindowPropertyFlags { cv::WND_PROP_FULLSCREEN = 0, cv::WND_PROP_AUTOSIZE = 1, cv::WND_PROP_ASPECT_RATIO = 2, cv::WND_PROP_OPENGL = 3, cv::WND_PROP_VISIBLE = 4, cv::WND_PROP_TOPMOST = 5 }
| Flags for cv::setWindowProperty / cv::getWindowProperty. More...

## Functions
int | cv::createTrackbar (const String &trackbarname, const String &winname, int *value, int count, TrackbarCallback onChange=0, void *userdata=0)
| Creates a trackbar and attaches it to the specified window. More...
void | cv::destroyAllWindows ()
| Destroys all of the HighGUI windows. More...
void | cv::destroyWindow (const String &winname)
| Destroys the specified window. More...
int | cv::getMouseWheelDelta (int flags)
| Gets the mouse-wheel motion delta, when handling mouse-wheel events cv::EVENT_MOUSEWHEEL and cv::EVENT_MOUSEHWHEEL. More...
int | cv::getTrackbarPos (const String &trackbarname, const String &winname)
| Returns the trackbar position. More...
Rect | cv::getWindowImageRect (const String &winname)
| Provides rectangle of image in the window. More...
double | cv::getWindowProperty (const String &winname, int prop_id)
| Provides parameters of a window. More...
void | cv::imshow (const String &winname, InputArray mat)
| Displays an image in the specified window. More...
void | cv::moveWindow (const String &winname, int x, int y)
| Moves window to the specified position. More...
void | cv::namedWindow (const String &winname, int flags=WINDOW_AUTOSIZE)
| Creates a window. More...
void | cv::resizeWindow (const String &winname, int width, int height)
| Resizes window to the specified size. More...
void | cv::resizeWindow (const String &winname, const cv::Size &size)
Rect | cv::selectROI (const String &windowName, InputArray img, bool showCrosshair=true, bool fromCenter=false)
| Selects ROI on the given image. Function creates a window and allows user to select a ROI using mouse. Controls: use `space` or `enter` to finish selection, use key `c` to cancel selection (function will return the zero cv::Rect). More...
Rect | cv::selectROI (InputArray img, bool showCrosshair=true, bool fromCenter=false)
void | cv::selectROIs (const String &windowName, InputArray img, std::vector< Rect > &boundingBoxes, bool showCrosshair=true, bool fromCenter=false)
| Selects ROIs on the given image. Function creates a window and allows user to select a ROIs using mouse. Controls: use `space` or `enter` to finish current selection and start a new one, use `esc` to terminate multiple ROI selection process. More...
void | cv::setMouseCallback (const String &winname, MouseCallback onMouse, void *userdata=0)
| Sets mouse handler for the specified window. More...
void | cv::setTrackbarMax (const String &trackbarname, const String &winname, int maxval)
| Sets the trackbar maximum position. More...
void | cv::setTrackbarMin (const String &trackbarname, const String &winname, int minval)
| Sets the trackbar minimum position. More...
void | cv::setTrackbarPos (const String &trackbarname, const String &winname, int pos)
| Sets the trackbar position. More...
void | cv::setWindowProperty (const String &winname, int prop_id, double prop_value)
| Changes parameters of a window dynamically. More...
void | cv::setWindowTitle (const String &winname, const String &title)
| Updates window title. More...
int | cv::startWindowThread ()
int | cv::waitKey (int delay=0)
| Waits for a pressed key. More...
int | cv::waitKeyEx (int delay=0)
| Similar to waitKey, but returns full key code. More...

## Detailed Description

While OpenCV was designed for use in full-scale applications and can be used within functionally rich UI frameworks (such as Qt*, WinForms*, or Cocoa*) or without any UI at all, sometimes there it is required to try functionality quickly and visualize the results. This is what the HighGUI module has been designed for.

It provides easy interface to:

- Create and manipulate windows that can display images and "remember" their content (no need to handle repaint events from OS).
- Add trackbars to the windows, handle simple mouse events as well as keyboard commands.

## Typedef Documentation

## § ButtonCallback

typedef void(* cv::ButtonCallback) (int state, void *userdata)

`#include <opencv2/highgui.hpp>`

Callback function for a button created by cv::createButton.

Parameters

  state | current state of the button. It could be -1 for a push button, 0 or 1 for a check/radio box button.
  userdata | The optional parameter.

## § MouseCallback

typedef void(* cv::MouseCallback) (int event, int x, int y, int flags, void *userdata)

`#include <opencv2/highgui.hpp>`

Callback function for mouse events. see cv::setMouseCallback.

Parameters

  event | one of the cv::MouseEventTypes constants.
  x | The x-coordinate of the mouse event.
  y | The y-coordinate of the mouse event.
  flags | one of the cv::MouseEventFlags constants.
  userdata | The optional parameter.

## § OpenGlDrawCallback

typedef void(* cv::OpenGlDrawCallback) (void *userdata)

`#include <opencv2/highgui.hpp>`

Callback function defined to be called every frame. See cv::setOpenGlDrawCallback.

Parameters

  userdata | The optional parameter.

## § TrackbarCallback

typedef void(* cv::TrackbarCallback) (int pos, void *userdata)

`#include <opencv2/highgui.hpp>`

Callback function for Trackbar see cv::createTrackbar.

Parameters

  pos | current position of the specified trackbar.
  userdata | The optional parameter.

## Enumeration Type Documentation

## § MouseEventFlags

enum cv::MouseEventFlags

`#include <opencv2/highgui.hpp>`

Mouse Event Flags see cv::MouseCallback.

Enumerator
EVENT_FLAG_LBUTTON Python: cv.EVENT_FLAG_LBUTTON | indicates that the left mouse button is down.
EVENT_FLAG_RBUTTON Python: cv.EVENT_FLAG_RBUTTON | indicates that the right mouse button is down.
EVENT_FLAG_MBUTTON Python: cv.EVENT_FLAG_MBUTTON | indicates that the middle mouse button is down.
EVENT_FLAG_CTRLKEY Python: cv.EVENT_FLAG_CTRLKEY | indicates that CTRL Key is pressed.
EVENT_FLAG_SHIFTKEY Python: cv.EVENT_FLAG_SHIFTKEY | indicates that SHIFT Key is pressed.
EVENT_FLAG_ALTKEY Python: cv.EVENT_FLAG_ALTKEY | indicates that ALT Key is pressed.

## § MouseEventTypes

enum cv::MouseEventTypes

`#include <opencv2/highgui.hpp>`

Mouse Events see cv::MouseCallback.

Enumerator
EVENT_MOUSEMOVE Python: cv.EVENT_MOUSEMOVE | indicates that the mouse pointer has moved over the window.
EVENT_LBUTTONDOWN Python: cv.EVENT_LBUTTONDOWN | indicates that the left mouse button is pressed.
EVENT_RBUTTONDOWN Python: cv.EVENT_RBUTTONDOWN | indicates that the right mouse button is pressed.
EVENT_MBUTTONDOWN Python: cv.EVENT_MBUTTONDOWN | indicates that the middle mouse button is pressed.
EVENT_LBUTTONUP Python: cv.EVENT_LBUTTONUP | indicates that left mouse button is released.
EVENT_RBUTTONUP Python: cv.EVENT_RBUTTONUP | indicates that right mouse button is released.
EVENT_MBUTTONUP Python: cv.EVENT_MBUTTONUP | indicates that middle mouse button is released.
EVENT_LBUTTONDBLCLK Python: cv.EVENT_LBUTTONDBLCLK | indicates that left mouse button is double clicked.
EVENT_RBUTTONDBLCLK Python: cv.EVENT_RBUTTONDBLCLK | indicates that right mouse button is double clicked.
EVENT_MBUTTONDBLCLK Python: cv.EVENT_MBUTTONDBLCLK | indicates that middle mouse button is double clicked.
EVENT_MOUSEWHEEL Python: cv.EVENT_MOUSEWHEEL | positive and negative values mean forward and backward scrolling, respectively.
EVENT_MOUSEHWHEEL Python: cv.EVENT_MOUSEHWHEEL | positive and negative values mean right and left scrolling, respectively.

## § QtButtonTypes

enum cv::QtButtonTypes

`#include <opencv2/highgui.hpp>`

Qt "button" type.

Enumerator
QT_PUSH_BUTTON Python: cv.QT_PUSH_BUTTON | Push button.
QT_CHECKBOX Python: cv.QT_CHECKBOX | Checkbox button.
QT_RADIOBOX Python: cv.QT_RADIOBOX | Radiobox button.
QT_NEW_BUTTONBAR Python: cv.QT_NEW_BUTTONBAR | Button should create a new buttonbar.

## § QtFontStyles

enum cv::QtFontStyles

`#include <opencv2/highgui.hpp>`

Qt font style.

Enumerator
QT_STYLE_NORMAL Python: cv.QT_STYLE_NORMAL | Normal font.
QT_STYLE_ITALIC Python: cv.QT_STYLE_ITALIC | Italic font.
QT_STYLE_OBLIQUE Python: cv.QT_STYLE_OBLIQUE | Oblique font.

## § QtFontWeights

enum cv::QtFontWeights

`#include <opencv2/highgui.hpp>`

Qt font weight.

Enumerator
QT_FONT_LIGHT Python: cv.QT_FONT_LIGHT | Weight of 25.
QT_FONT_NORMAL Python: cv.QT_FONT_NORMAL | Weight of 50.
QT_FONT_DEMIBOLD Python: cv.QT_FONT_DEMIBOLD | Weight of 63.
QT_FONT_BOLD Python: cv.QT_FONT_BOLD | Weight of 75.
QT_FONT_BLACK Python: cv.QT_FONT_BLACK | Weight of 87.

## § WindowFlags

enum cv::WindowFlags

`#include <opencv2/highgui.hpp>`

Flags for cv::namedWindow.

Enumerator
WINDOW_NORMAL Python: cv.WINDOW_NORMAL | the user can resize the window (no constraint) / also use to switch a fullscreen window to a normal size.
WINDOW_AUTOSIZE Python: cv.WINDOW_AUTOSIZE | the user cannot resize the window, the size is constrainted by the image displayed.
WINDOW_OPENGL Python: cv.WINDOW_OPENGL | window with opengl support.
WINDOW_FULLSCREEN Python: cv.WINDOW_FULLSCREEN | change the window to fullscreen.
WINDOW_FREERATIO Python: cv.WINDOW_FREERATIO | the image expends as much as it can (no ratio constraint).
WINDOW_KEEPRATIO Python: cv.WINDOW_KEEPRATIO | the ratio of the image is respected.
WINDOW_GUI_EXPANDED Python: cv.WINDOW_GUI_EXPANDED | status bar and tool bar
WINDOW_GUI_NORMAL Python: cv.WINDOW_GUI_NORMAL | old fashious way

## § WindowPropertyFlags

enum cv::WindowPropertyFlags

`#include <opencv2/highgui.hpp>`

Flags for cv::setWindowProperty / cv::getWindowProperty.

Enumerator
WND_PROP_FULLSCREEN Python: cv.WND_PROP_FULLSCREEN | fullscreen property (can be WINDOW_NORMAL or WINDOW_FULLSCREEN).
WND_PROP_AUTOSIZE Python: cv.WND_PROP_AUTOSIZE | autosize property (can be WINDOW_NORMAL or WINDOW_AUTOSIZE).
WND_PROP_ASPECT_RATIO Python: cv.WND_PROP_ASPECT_RATIO | window's aspect ration (can be set to WINDOW_FREERATIO or WINDOW_KEEPRATIO).
WND_PROP_OPENGL Python: cv.WND_PROP_OPENGL | opengl support.
WND_PROP_VISIBLE Python: cv.WND_PROP_VISIBLE | checks whether the window exists and is visible
WND_PROP_TOPMOST Python: cv.WND_PROP_TOPMOST | property to toggle normal window being topmost or not

## Function Documentation

## § createTrackbar()

int cv::createTrackbar | ( | const String & | trackbarname,
|  | const String & | winname,
|  | int * | value,
|  | int | count,
|  | TrackbarCallback | onChange = `0`,
|  | void * | userdata = `0`
| ) |  |

`#include <opencv2/highgui.hpp>`

Creates a trackbar and attaches it to the specified window.

The function createTrackbar creates a trackbar (a slider or range control) with the specified name and range, assigns a variable value to be a position synchronized with the trackbar and specifies the callback function onChange to be called on the trackbar position change. The created trackbar is displayed in the specified window winname.

Note

[Qt Backend Only] winname can be empty (or NULL) if the trackbar should be attached to the control panel.

Clicking the label of each trackbar enables editing the trackbar values manually.

Parameters

  trackbarname | Name of the created trackbar.
  winname | Name of the window that will be used as a parent of the created trackbar.
  value | Optional pointer to an integer variable whose value reflects the position of the slider. Upon creation, the slider position is defined by this variable.
  count | Maximal position of the slider. The minimal position is always 0.
  onChange | Pointer to the function to be called every time the slider changes position. This function should be prototyped as void Foo(int,void*); , where the first parameter is the trackbar position and the second parameter is the user data (see the next parameter). If the callback is the NULL pointer, no callbacks are called, but only value is updated.
  userdata | User data that is passed as is to the callback. It can be used to handle trackbar events without using global variables.

Examples:
  samples/cpp/camshiftdemo.cpp, samples/cpp/connected_components.cpp, samples/cpp/contours2.cpp, samples/cpp/demhist.cpp, samples/cpp/distrans.cpp, samples/cpp/edge.cpp, samples/cpp/falsecolor.cpp, samples/cpp/ffilldemo.cpp, samples/cpp/fitellipse.cpp, samples/cpp/laplace.cpp, samples/cpp/pca.cpp, samples/cpp/tutorial_code/HighGUI/AddingImagesTrackbar.cpp, samples/cpp/tutorial_code/Histograms_Matching/MatchTemplate_Demo.cpp, samples/cpp/tutorial_code/ImgProc/Morphology_1.cpp, samples/cpp/tutorial_code/ImgProc/Morphology_2.cpp, and samples/dnn/object_detection.cpp.

## § destroyAllWindows()

void cv::destroyAllWindows | ( |  | ) |

Python:
| None | = | cv.destroyAllWindows( |  | )

`#include <opencv2/highgui.hpp>`

Destroys all of the HighGUI windows.

The function destroyAllWindows destroys all of the opened HighGUI windows.

## § destroyWindow()

void cv::destroyWindow | ( | const String & | winname | ) |

Python:
| None | = | cv.destroyWindow( | winname | )

`#include <opencv2/highgui.hpp>`

Destroys the specified window.

The function destroyWindow destroys the window with the given name.

Parameters

  winname | Name of the window to be destroyed.

Examples:
  samples/cpp/camshiftdemo.cpp, samples/cpp/ffilldemo.cpp, samples/cpp/grabcut.cpp, and samples/cpp/shape_example.cpp.

## § getMouseWheelDelta()

int cv::getMouseWheelDelta | ( | int | flags | ) |

`#include <opencv2/highgui.hpp>`

Gets the mouse-wheel motion delta, when handling mouse-wheel events cv::EVENT_MOUSEWHEEL and cv::EVENT_MOUSEHWHEEL.

For regular mice with a scroll-wheel, delta will be a multiple of 120. The value 120 corresponds to a one notch rotation of the wheel or the threshold for action to be taken and one such action should occur for each delta. Some high-precision mice with higher-resolution freely-rotating wheels may generate smaller values.

For cv::EVENT_MOUSEWHEEL positive and negative values mean forward and backward scrolling, respectively. For cv::EVENT_MOUSEHWHEEL, where available, positive and negative values mean right and left scrolling, respectively.

With the C API, the macro CV_GET_WHEEL_DELTA(flags) can be used alternatively.

Note

Mouse-wheel events are currently supported only on Windows.

Parameters

  flags | The mouse callback flags parameter.

## § getTrackbarPos()

int cv::getTrackbarPos | ( | const String & | trackbarname,
|  | const String & | winname
| ) |  |

Python:
| retval | = | cv.getTrackbarPos( | trackbarname, winname | )

`#include <opencv2/highgui.hpp>`

Returns the trackbar position.

The function returns the current position of the specified trackbar.

Note

[Qt Backend Only] winname can be empty (or NULL) if the trackbar is attached to the control panel.

Parameters

  trackbarname | Name of the trackbar.
  winname | Name of the window that is the parent of the trackbar.

## § getWindowImageRect()

Rect cv::getWindowImageRect | ( | const String & | winname | ) |

Python:
| retval | = | cv.getWindowImageRect( | winname | )

`#include <opencv2/highgui.hpp>`

Provides rectangle of image in the window.

The function getWindowImageRect returns the client screen coordinates, width and height of the image rendering area.

Parameters

  winname | Name of the window.

See also
  resizeWindow moveWindow

## § getWindowProperty()

double cv::getWindowProperty | ( | const String & | winname,
|  | int | prop_id
| ) |  |

Python:
| retval | = | cv.getWindowProperty( | winname, prop_id | )

`#include <opencv2/highgui.hpp>`

Provides parameters of a window.

The function getWindowProperty returns properties of a window.

Parameters

  winname | Name of the window.
  prop_id | Window property to retrieve. The following operation flags are available: (cv::WindowPropertyFlags)

See also
  setWindowProperty

## § imshow()

void cv::imshow | ( | const String & | winname,
|  | InputArray | mat
| ) |  |

Python:
| None | = | cv.imshow( | winname, mat | )

`#include <opencv2/highgui.hpp>`

Displays an image in the specified window.

The function imshow displays an image in the specified window. If the window was created with the cv::WINDOW_AUTOSIZE flag, the image is shown with its original size, however it is still limited by the screen resolution. Otherwise, the image is scaled to fit the window. The function may scale the image, depending on its depth:

- If the image is 8-bit unsigned, it is displayed as is.
- If the image is 16-bit unsigned or 32-bit integer, the pixels are divided by 256. That is, the value range [0,255*256] is mapped to [0,255].
- If the image is 32-bit or 64-bit floating-point, the pixel values are multiplied by 255. That is, the value range [0,1] is mapped to [0,255].

If window was created with OpenGL support, cv::imshow also support ogl::Buffer , ogl::Texture2D and cuda::GpuMat as input.

If the window was not created before this function, it is assumed creating a window with cv::WINDOW_AUTOSIZE.

If you need to show an image that is bigger than the screen resolution, you will need to call namedWindow("", WINDOW_NORMAL) before the imshow.

Note
  This function should be followed by cv::waitKey function which displays the image for specified milliseconds. Otherwise, it won't display the image. For example, waitKey(0) will display the window infinitely until any keypress (it is suitable for image display). waitKey(25) will display a frame for 25 ms, after which display will be automatically closed. (If you put it in a loop to read videos, it will display the video frame-by-frame)

[Windows Backend Only] Pressing Ctrl+C will copy the image to the clipboard.

[Windows Backend Only] Pressing Ctrl+S will show a dialog to save the image.

Parameters

  winname | Name of the window.
  mat | Image to be shown.

Examples:
  fld_lines.cpp, samples/cpp/camshiftdemo.cpp, samples/cpp/connected_components.cpp, samples/cpp/contours2.cpp, samples/cpp/convexhull.cpp, samples/cpp/create_mask.cpp, samples/cpp/demhist.cpp, samples/cpp/distrans.cpp, samples/cpp/edge.cpp, samples/cpp/facedetect.cpp, samples/cpp/falsecolor.cpp, samples/cpp/ffilldemo.cpp, samples/cpp/fitellipse.cpp, samples/cpp/grabcut.cpp, samples/cpp/image_alignment.cpp, samples/cpp/kalman.cpp, samples/cpp/kmeans.cpp, samples/cpp/laplace.cpp, samples/cpp/lkdemo.cpp, samples/cpp/minarea.cpp, samples/cpp/pca.cpp, samples/cpp/peopledetect.cpp, samples/cpp/polar_transforms.cpp, samples/cpp/segment_objects.cpp, samples/cpp/shape_example.cpp, samples/cpp/squares.cpp, samples/cpp/train_HOG.cpp, samples/cpp/tutorial_code/features2D/Homography/homography_from_camera_displacement.cpp, samples/cpp/tutorial_code/features2D/Homography/pose_from_homography.cpp, samples/cpp/tutorial_code/HighGUI/AddingImagesTrackbar.cpp, samples/cpp/tutorial_code/Histograms_Matching/MatchTemplate_Demo.cpp, samples/cpp/tutorial_code/ImgProc/basic_drawing/Drawing_1.cpp, samples/cpp/tutorial_code/ImgProc/basic_drawing/Drawing_2.cpp, samples/cpp/tutorial_code/ImgProc/Morphology_1.cpp, samples/cpp/tutorial_code/ImgProc/Morphology_2.cpp, samples/cpp/tutorial_code/ImgProc/Pyramids/Pyramids.cpp, samples/cpp/tutorial_code/ImgProc/Smoothing/Smoothing.cpp, samples/cpp/tutorial_code/ImgTrans/copyMakeBorder_demo.cpp, samples/cpp/tutorial_code/ImgTrans/houghcircles.cpp, samples/cpp/tutorial_code/ImgTrans/houghlines.cpp, samples/cpp/tutorial_code/ImgTrans/Sobel_Demo.cpp, samples/cpp/tutorial_code/ml/introduction_to_pca/introduction_to_pca.cpp, samples/cpp/tutorial_code/photo/non_photorealistic_rendering/npr_demo.cpp, samples/cpp/tutorial_code/photo/seamless_cloning/cloning_demo.cpp, samples/cpp/videowriter_basic.cpp, samples/cpp/warpPerspective_demo.cpp, samples/cpp/watershed.cpp, samples/dnn/classification.cpp, samples/dnn/colorization.cpp, samples/dnn/object_detection.cpp, samples/dnn/openpose.cpp, samples/dnn/segmentation.cpp, samples/dnn/text_detection.cpp, samples/tapi/hog.cpp, and samples/tapi/squares.cpp.

## § moveWindow()

void cv::moveWindow | ( | const String & | winname,
|  | int | x,
|  | int | y
| ) |  |

Python:
| None | = | cv.moveWindow( | winname, x, y | )

`#include <opencv2/highgui.hpp>`

Moves window to the specified position.

Parameters

  winname | Name of the window.
  x | The new x-coordinate of the window.
  y | The new y-coordinate of the window.

Examples:
  samples/cpp/image_alignment.cpp, samples/cpp/polar_transforms.cpp, samples/cpp/shape_example.cpp, samples/cpp/tutorial_code/ImgProc/basic_drawing/Drawing_1.cpp, samples/cpp/tutorial_code/ImgProc/Morphology_1.cpp, and samples/cpp/warpPerspective_demo.cpp.

## § namedWindow()

void cv::namedWindow | ( | const String & | winname,
|  | int | flags = `WINDOW_AUTOSIZE`
| ) |  |

Python:
| None | = | cv.namedWindow( | winname[, flags] | )

`#include <opencv2/highgui.hpp>`

Creates a window.

The function namedWindow creates a window that can be used as a placeholder for images and trackbars. Created windows are referred to by their names.

If a window with the same name already exists, the function does nothing.

You can call cv::destroyWindow or cv::destroyAllWindows to close the window and de-allocate any associated memory usage. For a simple program, you do not really have to call these functions because all the resources and windows of the application are closed automatically by the operating system upon exit.

Note

Qt backend supports additional flags:

- WINDOW_NORMAL or WINDOW_AUTOSIZE: WINDOW_NORMAL enables you to resize the window, whereas WINDOW_AUTOSIZE adjusts automatically the window size to fit the displayed image (see imshow ), and you cannot change the window size manually.
- WINDOW_FREERATIO or WINDOW_KEEPRATIO: WINDOW_FREERATIO adjusts the image with no respect to its ratio, whereas WINDOW_KEEPRATIO keeps the image ratio.
- WINDOW_GUI_NORMAL or WINDOW_GUI_EXPANDED: WINDOW_GUI_NORMAL is the old way to draw the window without statusbar and toolbar, whereas WINDOW_GUI_EXPANDED is a new enhanced GUI. By default, flags == WINDOW_AUTOSIZE | WINDOW_KEEPRATIO | WINDOW_GUI_EXPANDED

Parameters

  winname | Name of the window in the window caption that may be used as a window identifier.
  flags | Flags of the window. The supported flags are: (cv::WindowFlags)

Examples:
  samples/cpp/camshiftdemo.cpp, samples/cpp/connected_components.cpp, samples/cpp/contours2.cpp, samples/cpp/create_mask.cpp, samples/cpp/demhist.cpp, samples/cpp/distrans.cpp, samples/cpp/edge.cpp, samples/cpp/falsecolor.cpp, samples/cpp/ffilldemo.cpp, samples/cpp/fitellipse.cpp, samples/cpp/grabcut.cpp, samples/cpp/image_alignment.cpp, samples/cpp/laplace.cpp, samples/cpp/lkdemo.cpp, samples/cpp/pca.cpp, samples/cpp/polar_transforms.cpp, samples/cpp/segment_objects.cpp, samples/cpp/train_HOG.cpp, samples/cpp/tutorial_code/HighGUI/AddingImagesTrackbar.cpp, samples/cpp/tutorial_code/Histograms_Matching/MatchTemplate_Demo.cpp, samples/cpp/tutorial_code/ImgProc/Morphology_1.cpp, samples/cpp/tutorial_code/ImgProc/Morphology_2.cpp, samples/cpp/tutorial_code/ImgProc/Smoothing/Smoothing.cpp, samples/cpp/tutorial_code/ImgTrans/copyMakeBorder_demo.cpp, samples/cpp/warpPerspective_demo.cpp, samples/cpp/watershed.cpp, samples/dnn/classification.cpp, samples/dnn/object_detection.cpp, samples/dnn/segmentation.cpp, samples/dnn/text_detection.cpp, and samples/tapi/squares.cpp.

## § resizeWindow() [1/2]

void cv::resizeWindow | ( | const String & | winname,
|  | int | width,
|  | int | height
| ) |  |

Python:
| None | = | cv.resizeWindow( | winname, width, height | )
| None | = | cv.resizeWindow( | winname, size | )

`#include <opencv2/highgui.hpp>`

Resizes window to the specified size.

Note

- The specified window size is for the image area. Toolbars are not counted.
- Only windows created without cv::WINDOW_AUTOSIZE flag can be resized.

Parameters

  winname | Window name.
  width | The new window width.
  height | The new window height.

## § resizeWindow() [2/2]

void cv::resizeWindow | ( | const String & | winname,
|  | const cv::Size & | size
| ) |  |

Python:
| None | = | cv.resizeWindow( | winname, width, height | )
| None | = | cv.resizeWindow( | winname, size | )

`#include <opencv2/highgui.hpp>`

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  winname | Window name.
  size | The new window size.

## § selectROI() [1/2]

Rect cv::selectROI | ( | const String & | windowName,
|  | InputArray | img,
|  | bool | showCrosshair = `true`,
|  | bool | fromCenter = `false`
| ) |  |

Python:
| retval | = | cv.selectROI( | windowName, img[, showCrosshair[, fromCenter]] | )
| retval | = | cv.selectROI( | img[, showCrosshair[, fromCenter]] | )

`#include <opencv2/highgui.hpp>`

Selects ROI on the given image. Function creates a window and allows user to select a ROI using mouse. Controls: use `space` or `enter` to finish selection, use key `c` to cancel selection (function will return the zero cv::Rect).

Parameters

  windowName | name of the window where selection process will be shown.
  img | image to select a ROI.
  showCrosshair | if true crosshair of selection rectangle will be shown.
  fromCenter | if true center of selection will match initial mouse position. In opposite case a corner of selection rectangle will correspont to the initial mouse position.

Returns
  selected ROI or empty rect if selection canceled.

Note
  The function sets it's own mouse callback for specified window using cv::setMouseCallback(windowName, ...). After finish of work an empty callback will be set for the used window.

## § selectROI() [2/2]

Rect cv::selectROI | ( | InputArray | img,
|  | bool | showCrosshair = `true`,
|  | bool | fromCenter = `false`
| ) |  |

Python:
| retval | = | cv.selectROI( | windowName, img[, showCrosshair[, fromCenter]] | )
| retval | = | cv.selectROI( | img[, showCrosshair[, fromCenter]] | )

`#include <opencv2/highgui.hpp>`

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## § selectROIs()

void cv::selectROIs | ( | const String & | windowName,
|  | InputArray | img,
|  | std::vector< Rect > & | boundingBoxes,
|  | bool | showCrosshair = `true`,
|  | bool | fromCenter = `false`
| ) |  |

Python:
| boundingBoxes | = | cv.selectROIs( | windowName, img[, showCrosshair[, fromCenter]] | )

`#include <opencv2/highgui.hpp>`

Selects ROIs on the given image. Function creates a window and allows user to select a ROIs using mouse. Controls: use `space` or `enter` to finish current selection and start a new one, use `esc` to terminate multiple ROI selection process.

Parameters

  windowName | name of the window where selection process will be shown.
  img | image to select a ROI.
  boundingBoxes | selected ROIs.
  showCrosshair | if true crosshair of selection rectangle will be shown.
  fromCenter | if true center of selection will match initial mouse position. In opposite case a corner of selection rectangle will correspont to the initial mouse position.

Note
  The function sets it's own mouse callback for specified window using cv::setMouseCallback(windowName, ...). After finish of work an empty callback will be set for the used window.

## § setMouseCallback()

void cv::setMouseCallback | ( | const String & | winname,
|  | MouseCallback | onMouse,
|  | void * | userdata = `0`
| ) |  |

`#include <opencv2/highgui.hpp>`

Sets mouse handler for the specified window.

Parameters

  winname | Name of the window.
  onMouse | Callback function for mouse events. See OpenCV samples on how to specify and use the callback.
  userdata | The optional parameter passed to the callback.

Examples:
  samples/cpp/camshiftdemo.cpp, samples/cpp/create_mask.cpp, samples/cpp/ffilldemo.cpp, samples/cpp/grabcut.cpp, samples/cpp/lkdemo.cpp, samples/cpp/warpPerspective_demo.cpp, and samples/cpp/watershed.cpp.

## § setTrackbarMax()

void cv::setTrackbarMax | ( | const String & | trackbarname,
|  | const String & | winname,
|  | int | maxval
| ) |  |

Python:
| None | = | cv.setTrackbarMax( | trackbarname, winname, maxval | )

`#include <opencv2/highgui.hpp>`

Sets the trackbar maximum position.

The function sets the maximum position of the specified trackbar in the specified window.

Note

[Qt Backend Only] winname can be empty (or NULL) if the trackbar is attached to the control panel.

Parameters

  trackbarname | Name of the trackbar.
  winname | Name of the window that is the parent of trackbar.
  maxval | New maximum position.

Examples:
  samples/cpp/falsecolor.cpp.

## § setTrackbarMin()

void cv::setTrackbarMin | ( | const String & | trackbarname,
|  | const String & | winname,
|  | int | minval
| ) |  |

Python:
| None | = | cv.setTrackbarMin( | trackbarname, winname, minval | )

`#include <opencv2/highgui.hpp>`

Sets the trackbar minimum position.

The function sets the minimum position of the specified trackbar in the specified window.

Note

[Qt Backend Only] winname can be empty (or NULL) if the trackbar is attached to the control panel.

Parameters

  trackbarname | Name of the trackbar.
  winname | Name of the window that is the parent of trackbar.
  minval | New minimum position.

Examples:
  samples/cpp/falsecolor.cpp.

## § setTrackbarPos()

void cv::setTrackbarPos | ( | const String & | trackbarname,
|  | const String & | winname,
|  | int | pos
| ) |  |

Python:
| None | = | cv.setTrackbarPos( | trackbarname, winname, pos | )

`#include <opencv2/highgui.hpp>`

Sets the trackbar position.

The function sets the position of the specified trackbar in the specified window.

Note

[Qt Backend Only] winname can be empty (or NULL) if the trackbar is attached to the control panel.

Parameters

  trackbarname | Name of the trackbar.
  winname | Name of the window that is the parent of trackbar.
  pos | New position.

Examples:
  samples/cpp/falsecolor.cpp.

## § setWindowProperty()

void cv::setWindowProperty | ( | const String & | winname,
|  | int | prop_id,
|  | double | prop_value
| ) |  |

Python:
| None | = | cv.setWindowProperty( | winname, prop_id, prop_value | )

`#include <opencv2/highgui.hpp>`

Changes parameters of a window dynamically.

The function setWindowProperty enables changing properties of a window.

Parameters

  winname | Name of the window.
  prop_id | Window property to edit. The supported operation flags are: (cv::WindowPropertyFlags)
  prop_value | New value of the window property. The supported flags are: (cv::WindowFlags)

## § setWindowTitle()

void cv::setWindowTitle | ( | const String & | winname,
|  | const String & | title
| ) |  |

Python:
| None | = | cv.setWindowTitle( | winname, title | )

`#include <opencv2/highgui.hpp>`

Updates window title.

Parameters

  winname | Name of the window.
  title | New title.

## § startWindowThread()

int cv::startWindowThread | ( |  | ) |

Python:
| retval | = | cv.startWindowThread( |  | )

`#include <opencv2/highgui.hpp>`

## § waitKey()

int cv::waitKey | ( | int | delay = `0` | ) |

Python:
| retval | = | cv.waitKey( | [, delay] | )

`#include <opencv2/highgui.hpp>`

Waits for a pressed key.

The function waitKey waits for a key event infinitely (when \(\texttt{delay}\leq 0\) ) or for delay milliseconds, when it is positive. Since the OS has a minimum time between switching threads, the function will not wait exactly delay ms, it will wait at least delay ms, depending on what else is running on your computer at that time. It returns the code of the pressed key or -1 if no key was pressed before the specified time had elapsed.

Note

This function is the only method in HighGUI that can fetch and handle events, so it needs to be called periodically for normal event processing unless HighGUI is used within an environment that takes care of event processing.

Note

The function only works if there is at least one HighGUI window created and the window is active. If there are several HighGUI windows, any of them can be active.

Parameters

  delay | Delay in milliseconds. 0 is the special value that means "forever".

Examples:
  fld_lines.cpp, samples/cpp/camshiftdemo.cpp, samples/cpp/connected_components.cpp, samples/cpp/contours2.cpp, samples/cpp/convexhull.cpp, samples/cpp/create_mask.cpp, samples/cpp/demhist.cpp, samples/cpp/distrans.cpp, samples/cpp/edge.cpp, samples/cpp/facedetect.cpp, samples/cpp/falsecolor.cpp, samples/cpp/ffilldemo.cpp, samples/cpp/fitellipse.cpp, samples/cpp/grabcut.cpp, samples/cpp/image_alignment.cpp, samples/cpp/kalman.cpp, samples/cpp/kmeans.cpp, samples/cpp/laplace.cpp, samples/cpp/lkdemo.cpp, samples/cpp/minarea.cpp, samples/cpp/pca.cpp, samples/cpp/peopledetect.cpp, samples/cpp/polar_transforms.cpp, samples/cpp/segment_objects.cpp, samples/cpp/shape_example.cpp, samples/cpp/squares.cpp, samples/cpp/train_HOG.cpp, samples/cpp/tutorial_code/features2D/Homography/homography_from_camera_displacement.cpp, samples/cpp/tutorial_code/features2D/Homography/pose_from_homography.cpp, samples/cpp/tutorial_code/HighGUI/AddingImagesTrackbar.cpp, samples/cpp/tutorial_code/Histograms_Matching/MatchTemplate_Demo.cpp, samples/cpp/tutorial_code/ImgProc/basic_drawing/Drawing_1.cpp, samples/cpp/tutorial_code/ImgProc/basic_drawing/Drawing_2.cpp, samples/cpp/tutorial_code/ImgProc/Morphology_1.cpp, samples/cpp/tutorial_code/ImgProc/Morphology_2.cpp, samples/cpp/tutorial_code/ImgProc/Pyramids/Pyramids.cpp, samples/cpp/tutorial_code/ImgProc/Smoothing/Smoothing.cpp, samples/cpp/tutorial_code/ImgTrans/copyMakeBorder_demo.cpp, samples/cpp/tutorial_code/ImgTrans/houghcircles.cpp, samples/cpp/tutorial_code/ImgTrans/houghlines.cpp, samples/cpp/tutorial_code/ImgTrans/Sobel_Demo.cpp, samples/cpp/tutorial_code/ml/introduction_to_pca/introduction_to_pca.cpp, samples/cpp/tutorial_code/photo/non_photorealistic_rendering/npr_demo.cpp, samples/cpp/tutorial_code/photo/seamless_cloning/cloning_demo.cpp, samples/cpp/videowriter_basic.cpp, samples/cpp/warpPerspective_demo.cpp, samples/cpp/watershed.cpp, samples/dnn/classification.cpp, samples/dnn/colorization.cpp, samples/dnn/object_detection.cpp, samples/dnn/openpose.cpp, samples/dnn/segmentation.cpp, samples/dnn/text_detection.cpp, samples/tapi/hog.cpp, and samples/tapi/squares.cpp.

## § waitKeyEx()

int cv::waitKeyEx | ( | int | delay = `0` | ) |

Python:
| retval | = | cv.waitKeyEx( | [, delay] | )

`#include <opencv2/highgui.hpp>`

Similar to waitKey, but returns full key code.

Note

Key code is implementation specific and depends on used backend: QT/GTK/Win32/etc